(function() {
  var Column, Util;
  Util = require('./util');
  Column = (function() {
    var alignCenter, alignLeft, alignRight, padCenter, padLeft, padRight, repeat;
    alignLeft = 'left';
    alignCenter = 'center';
    alignRight = 'right';
    padLeft = 'left';
    padCenter = 'center';
    padRight = 'right';
    repeat = Util.repeat;
    function Column(content, align, colspan) {
      this.content = content;
      this.align = align;
      this.colspan = colspan;
      this.colspan || (this.colspan = 1);
    }
    Column.prototype.getColspan = function() {
      return this.colspan;
    };
    Column.prototype.pad = function(str, len, pad, padMode) {
      var left, padlen, right;
      if (len + 1 >= str.length) {
        switch (padMode) {
          case padLeft:
            return Array(len + 1 - str.length).join(pad) + str;
          case padCenter:
            right = Math.ceil((padlen = len - str.length) / 2);
            left = padlen - right;
            return Array(left + 1).join(pad) + str + Array(right + 1).join(pad);
          case padRight:
            return str + Array(len + 1 - str.length).join(pad);
        }
      }
    };
    Column.prototype.render = function(columnWidth, padding) {
      var item, lines, padMode, paddedLines, _i, _len;
      padding || (padding = 0);
      columnWidth -= padding * 2;
      if (columnWidth < 1) {
        throw new Error("Padding " + padding + " is greater than the column width");
      }
      switch (this.align) {
        case alignLeft:
          padMode = padRight;
          break;
        case alignCenter:
          padMode = padCenter;
          break;
        case alignRight:
          padMode = padLeft;
          break;
        default:
          padMode = padRight;
      }
      lines = this.content.split("\n");
      paddedLines = [];
      for (_i = 0, _len = lines.length; _i < _len; _i++) {
        item = lines[_i];
        paddedLines[paddedLines.length] = repeat(' ', padding) + this.pad(item, columnWidth, ' ', padMode) + repeat(' ', padding);
      }
      return paddedLines.join("\n");
    };
    return Column;
  })();
  module.exports = Column;
}).call(this);
