(function() {
  var Column, Row, Util;
  Util = require('./util');
  Column = require('./column');
  Row = (function() {
    var repeat, sum, vertical;
    vertical = '|';
    repeat = Util.repeat;
    sum = Util.sum;
    function Row() {
      this.columnWidths = [];
      this.columns = [];
    }
    Row.prototype.appendColumn = function(column) {
      this.columns[this.columns.length] = column;
      return this;
    };
    Row.prototype.createColumn = function(content, align, colspan) {
      appendColumn(new Column(content, align, colspan));
      return this;
    };
    Row.prototype.render = function(columnWidths, padding) {
      var colNum, colspan, column, columnWidth, item, line, maxHeight, remainingWidth, rendered, result, slice, _i, _j, _len, _len2, _ref;
      padding || (padding = 0);
      if (this.columns.length === 0) {
        appendColumn(new Column);
      }
      rendered = [];
      colNum = maxHeight = 0;
      _ref = this.columns;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        column = _ref[_i];
        colspan = column.getColspan();
        if (colNum + colspan > columnWidths.length) {
          throw new Error('There are too many columns');
        }
        slice = this.betterSlice(columnWidths, colNum, colspan);
        columnWidth = (colspan - 1) + sum(slice);
        result = column.render(columnWidth, padding).split("\n");
        this.columnWidths[this.columnWidths.length] = columnWidth;
        rendered[rendered.length] = result;
        maxHeight = Math.max(maxHeight, result.length);
        colNum += colspan;
      }
      if (colNum < columnWidths.length) {
        remainingWidth = (columnWidths.length - colNum - 1) + sum(columnWidths.slice(colNum));
        rendered[rendered.length] = [repeat(' ', remainingWidth)];
        this.columnWidths[this.columnWidths.length] = remainingWidth;
      }
      result = '';
      line = 0;
      while (line < maxHeight) {
        result += vertical;
        for (_j = 0, _len2 = rendered.length; _j < _len2; _j++) {
          item = rendered[_j];
          if (item[line]) {
            result += item[line];
          } else {
            result += repeat(' ', item[0].length);
          }
          result += vertical;
        }
        result += "\n";
        line++;
      }
      return result;
    };
    Row.prototype.betterSlice = function(array, offset, length) {
      var slice;
      if (!length) {
        slice = array.slice(offset);
      } else if (length >= 0) {
        slice = array.slice(offset, offset + length);
      }
      return slice = array.slice(offset, length);
    };
    Row.prototype.getColumnWidths = function() {
      return this.columnWidths;
    };
    return Row;
  })();
  module.exports = Row;
}).call(this);
